#pragma once
#include <vector>
#include <time.h>
#include <xsi_application.h>
#include <xsi_context.h>
#include <xsi_toolcontext.h>
#include <xsi_polygonmesh.h>
#include <xsi_point.h>
#include <xsi_edge.h>
#include <xsi_vertex.h>
#include <xsi_triangle.h>
#include <xsi_polygonnode.h>
#include <xsi_polygonface.h>
#include <xsi_primitive.h>
#include <xsi_subcomponent.h>
#include <xsi_model.h>
#include <xsi_subcomponent.h>
#include <xsi_nurbssurfacemesh.h>
#include <xsi_nurbssurface.h>
#include <xsi_meshbuilder.h>
#include <xsi_PPGLayout.h>
#include <xsi_kinematics.h>
#include <xsi_comapihandler.h>

#ifndef linux
#define WIN32_LEAN_AND_MEAN
#include <windows.h> // Needed for OpenGL on windows
#endif

using namespace XSI;
using namespace XSI::MATH;

const void	GetPointRefFrame(ToolContext& in_ctxt,X3DObject& in_obj, Vertex& in_vert, CVector3& outX, CVector3& outY, CVector3& outZ);
const void	GetEdgeRefFrame(ToolContext& in_ctxt,X3DObject& in_obj, Edge& in_edge, CVector3& outX, CVector3& outY, CVector3& outZ);
const void	GetPolyRefFrame(ToolContext& in_ctxt, X3DObject& in_obj, PolygonFace& in_poly, CVector3& outX, CVector3& outY, CVector3& outZ);
const CVector3  AlignPrimitiveToComponentRefFrame(ToolContext& in_ctxt, PolygonFace& in_poly,X3DObject& in_obj, CVector3& out_rotx,CVector3& out_roty,CVector3& out_rotz, bool switchaxes, bool objKineMult);
const CVector3	getEdgeNormal(ToolContext& in_ctxt,Edge &in_edge,bool in_mulmatrix);
const CVector3	getVertexNormal(ToolContext& in_ctxt,Vertex &in_v, bool in_mulmatrix);
const CVector3	getPolyNormal(ToolContext& in_ctxt, PolygonFace &in_poly, bool in_mulmatrix);
const CStatus	GetModelBoudingBox(X3DObject &in_obj, CVector3 &out_bboxmin, CVector3 &out_bboxmax, CVector3 &out_bboxhalfsize, bool useInputTransform, CTransformation in_ct );
const void		GetBoudingBox(X3DObject &in_obj, CVector3 &out_bboxmin, CVector3 &out_bboxmax, CVector3 &out_bboxhalfsize, bool useInputTransform, CTransformation in_ct );

const CStatus GetSinglePolyLocationSample3(ToolContext& in_ctxt, X3DObject& in_obj, CVector3 in_raysample, LONG polyInd, CVector3 &out_pos);
const CStatus GetLocationSamples(ToolContext& in_ctxt, X3DObject& l_obj, CVector3 in_direction, CVector3Array& in_raysamples, std::vector<double>& out_pos, std::vector<LONG>& out_polyInd);

const void			BuildCircleSamples(ToolContext& in_ctxt, double scale,LONG in_count, CVector3 center, CVector3 rotx,CVector3 roty,CVector3 rotz,CVector3Array& out_samples);
const X3DObject		GetMultipleComponents(ToolContext& in_ctxt,CRef &target, CRefArray& out_polys);
const CRefArray		ExpandSelection( ToolContext& in_ctxt, CRefArray sel);		//convert subcomponent selection to objects
const CStatus		GetSinglePolyLocationSample2(ToolContext& in_ctxt, X3DObject& in_obj, CVector3 in_raysample, LONG polyInd, CVector3 &out_pos, LONG& out_polyInd);